<html>
<head>
<title>OgreD3D11Device.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a2df88393729a3f182c00116937c948.html">Direct3D11</a>      </li>
      <li class="navelem"><a class="el" href="dir_80c990f15d364d52e4690b415f060ae9.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreD3D11Device.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreD3D11Device_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __D3D11DEVICE_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __D3D11DEVICE_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D11Prerequisites_8h.html">OgreD3D11Prerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre
<a name="l00035"></a>00035 {
<a name="l00036"></a><a class="code" href="classOgre_1_1D3D11Device.html">00036</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D11Device.html">D3D11Device</a>
<a name="l00037"></a>00037     {
<a name="l00038"></a>00038     <span class="keyword">private</span>:
<a name="l00039"></a><a class="code" href="classOgre_1_1D3D11Device.html#a8d70683dad08253cb02c2ecb9cbc6962">00039</a>         ID3D11Device * <a class="code" href="classOgre_1_1D3D11Device.html#a8d70683dad08253cb02c2ecb9cbc6962">mD3D11Device</a>;
<a name="l00040"></a><a class="code" href="classOgre_1_1D3D11Device.html#a9a5cfd490ce0713d54eaf4eced71b961">00040</a>         ID3D11DeviceContext * <a class="code" href="classOgre_1_1D3D11Device.html#a9a5cfd490ce0713d54eaf4eced71b961">mImmediateContext</a>;
<a name="l00041"></a><a class="code" href="classOgre_1_1D3D11Device.html#a93a674dee9a69f29ddd8e16266fee7c7">00041</a>         ID3D11InfoQueue * <a class="code" href="classOgre_1_1D3D11Device.html#a93a674dee9a69f29ddd8e16266fee7c7">mInfoQueue</a>; 
<a name="l00042"></a>00042 
<a name="l00043"></a><a class="code" href="structOgre_1_1D3D11Device_1_1ThreadInfo.html">00043</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1D3D11Device_1_1ThreadInfo.html">ThreadInfo</a>
<a name="l00044"></a>00044         {
<a name="l00045"></a><a class="code" href="structOgre_1_1D3D11Device_1_1ThreadInfo.html#a11ee902ec830c6d518075fa5e107af67">00045</a>             ID3D11DeviceContext* <a class="code" href="structOgre_1_1D3D11Device_1_1ThreadInfo.html#a11ee902ec830c6d518075fa5e107af67">mContext</a>;
<a name="l00046"></a><a class="code" href="structOgre_1_1D3D11Device_1_1ThreadInfo.html#a3658ef1a084d92680086aba8298593bb">00046</a>             <span class="keywordtype">void</span>* <a class="code" href="structOgre_1_1D3D11Device_1_1ThreadInfo.html#a3658ef1a084d92680086aba8298593bb">mEventHandle</a>;
<a name="l00047"></a>00047 
<a name="l00048"></a><a class="code" href="structOgre_1_1D3D11Device_1_1ThreadInfo.html#acbf149d44a2f5a2295e0de27c05eb3f8">00048</a>             <a class="code" href="structOgre_1_1D3D11Device_1_1ThreadInfo.html#acbf149d44a2f5a2295e0de27c05eb3f8">ThreadInfo</a>(ID3D11DeviceContext* context)
<a name="l00049"></a>00049                 : <a class="code" href="structOgre_1_1D3D11Device_1_1ThreadInfo.html#a11ee902ec830c6d518075fa5e107af67">mContext</a>(context)
<a name="l00050"></a>00050                 , <a class="code" href="structOgre_1_1D3D11Device_1_1ThreadInfo.html#a3658ef1a084d92680086aba8298593bb">mEventHandle</a>(0)
<a name="l00051"></a>00051             {
<a name="l00052"></a>00052                 <a class="code" href="structOgre_1_1D3D11Device_1_1ThreadInfo.html#a3658ef1a084d92680086aba8298593bb">mEventHandle</a> = CreateEvent(0, <span class="keyword">false</span>, <span class="keyword">false</span>, <span class="stringliteral">&quot;ThreadContextEvent&quot;</span>);
<a name="l00053"></a>00053             }
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="structOgre_1_1D3D11Device_1_1ThreadInfo.html#a46a028645e751ca856f516276529de4c">00055</a>             <a class="code" href="structOgre_1_1D3D11Device_1_1ThreadInfo.html#a46a028645e751ca856f516276529de4c">~ThreadInfo</a>()
<a name="l00056"></a>00056             {
<a name="l00057"></a>00057                 <a class="code" href="structOgre_1_1D3D11Device_1_1ThreadInfo.html#a11ee902ec830c6d518075fa5e107af67">mContext</a>-&gt;Release();
<a name="l00058"></a>00058                 <a class="code" href="structOgre_1_1D3D11Device_1_1ThreadInfo.html#a11ee902ec830c6d518075fa5e107af67">mContext</a> = 0;
<a name="l00059"></a>00059 
<a name="l00060"></a>00060                 CloseHandle(<a class="code" href="structOgre_1_1D3D11Device_1_1ThreadInfo.html#a3658ef1a084d92680086aba8298593bb">mEventHandle</a>);
<a name="l00061"></a>00061             }
<a name="l00062"></a>00062         };
<a name="l00063"></a>00063 
<a name="l00064"></a>00064         <a class="code" href="classOgre_1_1D3D11Device.html#a0795f202077b6d65db6f0eb208d17213">D3D11Device</a>();
<a name="l00065"></a>00065     <span class="keyword">public</span>:
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068         <a class="code" href="classOgre_1_1D3D11Device.html#a0795f202077b6d65db6f0eb208d17213">D3D11Device</a>(ID3D11Device * device);
<a name="l00069"></a>00069 
<a name="l00070"></a>00070         <a class="code" href="classOgre_1_1D3D11Device.html#a0c0587b80f6c468b5b21bd46832eb755">~D3D11Device</a>();
<a name="l00071"></a>00071 
<a name="l00072"></a><a class="code" href="classOgre_1_1D3D11Device.html#a929a00f1189ae2b937a4e9d30120b09b">00072</a>         <span class="keyword">inline</span> ID3D11DeviceContext * <a class="code" href="classOgre_1_1D3D11Device.html#a929a00f1189ae2b937a4e9d30120b09b">GetImmediateContext</a>()
<a name="l00073"></a>00073         {
<a name="l00074"></a>00074             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1D3D11Device.html#a9a5cfd490ce0713d54eaf4eced71b961">mImmediateContext</a>;
<a name="l00075"></a>00075         }
<a name="l00076"></a>00076         
<a name="l00077"></a><a class="code" href="classOgre_1_1D3D11Device.html#af0022ec16af8d0dff758e8cfb2170e03">00077</a>         <span class="keyword">inline</span> ID3D11Device * <a class="code" href="classOgre_1_1D3D11Device.html#af0022ec16af8d0dff758e8cfb2170e03">operator-&gt;</a>()<span class="keyword"> const</span>
<a name="l00078"></a>00078 <span class="keyword">        </span>{
<a name="l00079"></a>00079             assert(<a class="code" href="classOgre_1_1D3D11Device.html#a8d70683dad08253cb02c2ecb9cbc6962">mD3D11Device</a>); 
<a name="l00080"></a>00080             <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1D3D11Device.html#a4eb292689eb4fcd1e29a7e4f80663d06abce74856acf97de3498206392d88f005">D3D_NO_EXCEPTION</a> != <a class="code" href="classOgre_1_1D3D11Device.html#a7505d8623d4970003cbd597753b8c258">mExceptionsErrorLevel</a>)
<a name="l00081"></a>00081             {
<a name="l00082"></a>00082                 <a class="code" href="classOgre_1_1D3D11Device.html#a39e903a8c0e7dedef21ce3658dd7a076">clearStoredErrorMessages</a>();
<a name="l00083"></a>00083             }
<a name="l00084"></a>00084             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1D3D11Device.html#a8d70683dad08253cb02c2ecb9cbc6962">mD3D11Device</a>;
<a name="l00085"></a>00085         }
<a name="l00086"></a>00086 
<a name="l00087"></a>00087         <span class="keyword">const</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11Device.html#a39e903a8c0e7dedef21ce3658dd7a076">clearStoredErrorMessages</a>(  ) <span class="keyword">const</span>;
<a name="l00088"></a>00088 
<a name="l00089"></a>00089         ID3D11Device * <a class="code" href="classOgre_1_1D3D11Device.html#a179d5cf3029eafbcad3a48640b2ae812">operator=</a>(ID3D11Device * device);
<a name="l00090"></a>00090         <span class="keyword">const</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D11Device.html#a71a26ff3d1f1c4cc288537dc2d4f203d">isNull</a>();
<a name="l00091"></a>00091         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1D3D11Device.html#aeb63562a23276cc43f27b4921dbdb1c6">getErrorDescription</a>(<span class="keyword">const</span> HRESULT hr = NO_ERROR) <span class="keyword">const</span>;
<a name="l00092"></a>00092 
<a name="l00093"></a><a class="code" href="classOgre_1_1D3D11Device.html#a1a4d6bc3fa52a6d02bc7744f0db4e319">00093</a>         <span class="keyword">inline</span> <span class="keyword">const</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D11Device.html#a1a4d6bc3fa52a6d02bc7744f0db4e319">isError</a>(  )<span class="keyword"> const</span>
<a name="l00094"></a>00094 <span class="keyword">        </span>{
<a name="l00095"></a>00095             <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1D3D11Device.html#a4eb292689eb4fcd1e29a7e4f80663d06abce74856acf97de3498206392d88f005">D3D_NO_EXCEPTION</a> == <a class="code" href="classOgre_1_1D3D11Device.html#a7505d8623d4970003cbd597753b8c258">mExceptionsErrorLevel</a>)
<a name="l00096"></a>00096             {
<a name="l00097"></a>00097                 <span class="keywordflow">return</span>  <span class="keyword">false</span>;
<a name="l00098"></a>00098             }
<a name="l00099"></a>00099 
<a name="l00100"></a>00100             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1D3D11Device.html#ab857859bfe05b1fb33f980a7f94e4fc4">_getErrorsFromQueue</a>();
<a name="l00101"></a>00101         }
<a name="l00102"></a>00102 
<a name="l00103"></a>00103         <span class="keyword">const</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D11Device.html#ab857859bfe05b1fb33f980a7f94e4fc4">_getErrorsFromQueue</a>() <span class="keyword">const</span>;
<a name="l00104"></a>00104         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11Device.html#a3aafbb2edb78e43c2e355e8745284497">release</a>();
<a name="l00105"></a>00105         ID3D11Device * <span class="keyword">get</span>();
<a name="l00106"></a>00106 
<a name="l00107"></a><a class="code" href="classOgre_1_1D3D11Device.html#a4eb292689eb4fcd1e29a7e4f80663d06">00107</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1D3D11Device.html#a4eb292689eb4fcd1e29a7e4f80663d06">eExceptionsErrorLevel</a>
<a name="l00108"></a>00108         {
<a name="l00109"></a><a class="code" href="classOgre_1_1D3D11Device.html#a4eb292689eb4fcd1e29a7e4f80663d06abce74856acf97de3498206392d88f005">00109</a>             <a class="code" href="classOgre_1_1D3D11Device.html#a4eb292689eb4fcd1e29a7e4f80663d06abce74856acf97de3498206392d88f005">D3D_NO_EXCEPTION</a>,
<a name="l00110"></a><a class="code" href="classOgre_1_1D3D11Device.html#a4eb292689eb4fcd1e29a7e4f80663d06a079a92e01130c04b8ef95020ccb09f8e">00110</a>             <a class="code" href="classOgre_1_1D3D11Device.html#a4eb292689eb4fcd1e29a7e4f80663d06a079a92e01130c04b8ef95020ccb09f8e">D3D_CORRUPTION</a>,
<a name="l00111"></a><a class="code" href="classOgre_1_1D3D11Device.html#a4eb292689eb4fcd1e29a7e4f80663d06a08f88a5c3e3b6f4d9ef9ecf5b9cd56ac">00111</a>             <a class="code" href="classOgre_1_1D3D11Device.html#a4eb292689eb4fcd1e29a7e4f80663d06a08f88a5c3e3b6f4d9ef9ecf5b9cd56ac">D3D_ERROR</a>,
<a name="l00112"></a><a class="code" href="classOgre_1_1D3D11Device.html#a4eb292689eb4fcd1e29a7e4f80663d06a1dfb5d815cfbec36f4cd28728a6e3dc4">00112</a>             <a class="code" href="classOgre_1_1D3D11Device.html#a4eb292689eb4fcd1e29a7e4f80663d06a1dfb5d815cfbec36f4cd28728a6e3dc4">D3D_WARNING</a>,
<a name="l00113"></a><a class="code" href="classOgre_1_1D3D11Device.html#a4eb292689eb4fcd1e29a7e4f80663d06a7a25732bdeaff6cf1fe48d92128e47e4">00113</a>             <a class="code" href="classOgre_1_1D3D11Device.html#a4eb292689eb4fcd1e29a7e4f80663d06a7a25732bdeaff6cf1fe48d92128e47e4">D3D_INFO</a>,
<a name="l00114"></a>00114         };
<a name="l00115"></a>00115 
<a name="l00116"></a><a class="code" href="classOgre_1_1D3D11Device.html#a7505d8623d4970003cbd597753b8c258">00116</a>         <span class="keyword">static</span> <a class="code" href="classOgre_1_1D3D11Device.html#a4eb292689eb4fcd1e29a7e4f80663d06">eExceptionsErrorLevel</a> <a class="code" href="classOgre_1_1D3D11Device.html#a7505d8623d4970003cbd597753b8c258">mExceptionsErrorLevel</a>;
<a name="l00117"></a>00117         <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11Device.html#ace628751d629a8faf3ce557c16748959">setExceptionsErrorLevel</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1D3D11Device.html#a4eb292689eb4fcd1e29a7e4f80663d06">eExceptionsErrorLevel</a> exceptionsErrorLevel);
<a name="l00118"></a>00118         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1D3D11Device.html#a4eb292689eb4fcd1e29a7e4f80663d06">eExceptionsErrorLevel</a> <a class="code" href="classOgre_1_1D3D11Device.html#ab57cfb687240679dc8cf07b6c82ce8d6">getExceptionsErrorLevel</a>();
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a>00121     };
<a name="l00122"></a>00122 }
<a name="l00123"></a>00123 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
